package modeler.literals;

import java.util.Dictionary;
import java.util.Hashtable;

public class TupleMap {

	public TupleMap(int dimension) {
		this.dimension = dimension;
		this.freeNo = 0;
	}

	public int getDimension() {
		return this.dimension;
	}

	public TupleLiteral getTupleLiteral(boolean positive, IntegerTuple t) {
		if (this.contains(t)) {
			try {
				return new TupleLiteral(positive, t, this.getNo(t));
			} catch (NotFoundException e) {
				assert false : "Should not happen - tuple must be in the map when here.";
				return null;
			}
		} else {
			this.tuples.put(t, ++this.freeNo);
			return new TupleLiteral(positive, t, this.freeNo);
		}
	}

	public int getNo(IntegerTuple t) throws NotFoundException {
		if (this.contains(t)) {
			return this.tuples.get(t);
		} else {
			throw new NotFoundException("Given tuple has not been found inside the TupleMap.");
		}
	}

	public boolean contains(IntegerTuple t) {
		return this.tuples.get(t) != null;
	}

	protected final int dimension;

	protected int freeNo;

	protected Dictionary<IntegerTuple, Integer> tuples = new Hashtable<IntegerTuple, Integer>();

}
